'''
###########################
# photomaster text blocks #
########################### 
Based on Photomaster's tutorial Marble Cut Slab from GimpChat
Brian Andersen June 2017
version 1b

  ...................................................... 
####################
# COPYRIGHT NOTICE #
###############################################################################
# This program is free software you can redistribute it and/or modify         #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation either version 3 of the License, or            #
# (at your option) any later version.                                         #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY without even the implied warranty of               #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
# You should have received a copy of the GNU General Public License           #
# along with this program if not, you can view the GNU General Public         #
# License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html  #
# Alternatively you can write to the Free Software Foundation, Inc., 675 Mass #
# Ave, Cambridge, MA 02139, USA.                                              #
###############################################################################

'''
#!/usr/bin/env python
from gimpfu import *

def BA_PhotomasterBlocksb (inImage, inDrawable,
                         sizeup1, thlc, pat1, dbev1,
                         sizeup2, bhlc, pat2, dbev2, 
                         sizeup3, pat3, col3, bumpheight): 

    pdb.gimp_context_push()
    pdb.gimp_context_set_defaults()

    width  = inImage.width
    height = inImage.height
    type   = inImage.base_type
    dir = 0
 
    wrkImage = pdb.gimp_image_new (width, height, type) 
    oriTXT = pdb.gimp_layer_new_from_drawable(inDrawable, wrkImage)     # background layer
    oriTXT.mode = NORMAL_MODE
    oriTXT.name = "Text RH"
    oriTXT.opacity = 100.0 
    wrkImage.add_layer(oriTXT, 0)
    pdb.gimp_item_set_visible(oriTXT, 1)    
    alpha=pdb.gimp_drawable_has_alpha(oriTXT)
    if not alpha:
        pdb.gimp_layer_add_alpha (oriTXT)    
    name = pdb.gimp_image_get_name(wrkImage)
    txtPAD = oriTXT.copy()
    txtPAD.mode = NORMAL_MODE
    txtPAD.opacity = 100.0 
    txtPAD.name = "Background RH"
    wrkImage.add_layer(txtPAD, 0)
    pdb.gimp_item_set_visible(txtPAD, True)
    pdb.gimp_image_set_active_layer(wrkImage, txtPAD)
    pdb.gimp_selection_layer_alpha(txtPAD)
    non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(wrkImage)
    pdb.gimp_selection_none(wrkImage)
    if non_empty:
        textWidth = x2-x1
        textHeight= y2-y1
    else:
        pdb.gimp_message('SCRIPT USES A TEXT LAYER!!!\n Script Ended')
        return()
    pdb.gimp_image_set_active_layer(wrkImage, oriTXT)
    pdb.gimp_image_crop(wrkImage, textWidth, textHeight, x1, y1)
    pdb.gimp_image_set_active_layer(wrkImage, txtPAD)
    pdb.gimp_edit_clear(txtPAD)
    pdb.gimp_layer_resize(txtPAD, textWidth+sizeup1,textHeight+sizeup1,0,0)
    pdb.gimp_image_resize_to_layers(wrkImage)
    pdb.gimp_layer_set_offsets(oriTXT, sizeup1/2,sizeup1/2) 
    pdb.gimp_context_set_pattern(pat1)
    pdb.gimp_drawable_fill(txtPAD, 4)
    pdb.gimp_image_set_active_layer(wrkImage, oriTXT)
    pdb.gimp_selection_layer_alpha(oriTXT)
    pdb.gimp_image_set_active_layer(wrkImage, txtPAD)
    non_empty = pdb.gimp_edit_cut(txtPAD)
    pdb.gimp_item_set_visible(oriTXT, False)
    pdb.gimp_selection_none(wrkImage) 

    #### the first bevel
    pdb.script_fu_mhbevel3dimg22(wrkImage,txtPAD,1,dbev1,dir,1,5,3,0,0) ##### here it is direction____
    fbgLay = txtPAD.copy()
    fbgLay.mode = NORMAL_MODE
    fbgLay.opacity = 100.0 
    fbgLay.name = "Background Copy_RH?"
    wrkImage.add_layer (fbgLay, 0)
    pdb.gimp_edit_clear(fbgLay)
    imgs =  gimp.image_list()
    img0 = gimp.image_list()[0]
    img1 = gimp.image_list()[1]
    img0lay0,img0lay1,img0lay2=img0.layers
    img1lay0,img1lay1,img1lay2=img1.layers
    new_width=img0.width
    new_height=img0.height
    pdb.gimp_image_resize(img1, new_width, new_height,0,0)
    offset_x, offset_y = pdb.gimp_drawable_offsets(img0lay0)
    pdb.gimp_layer_resize_to_image_size(img1lay0)
    pdb.gimp_layer_resize_to_image_size(img1lay1)
    cutLay=pdb.gimp_layer_new(img1,new_width,new_height,1,"Cut Edges RH",100,NORMAL_MODE)
    pdb.gimp_image_insert_layer(img1,cutLay,None,0)
    non_empty = pdb.gimp_edit_copy(img0lay2)
    floating_sel = pdb.gimp_edit_paste(img1lay2, True)
    pdb.gimp_floating_sel_attach(floating_sel,img1lay2)
    pdb.gimp_item_set_visible(img1lay2,True)
    pdb.gimp_layer_resize_to_image_size(img1lay2)
    non_empty = pdb.gimp_edit_copy(img0lay1)
    floating_sel = pdb.gimp_edit_paste(img1lay1, True)
    pdb.gimp_floating_sel_attach(floating_sel,img1lay1)
    pdb.gimp_floating_sel_anchor(floating_sel)
    pdb.gimp_layer_resize_to_image_size(img1lay1)
    non_empty = pdb.gimp_edit_copy(img0lay0)
    floating_sel = pdb.gimp_edit_paste(img1lay0, True)
    pdb.gimp_floating_sel_attach(floating_sel,img1lay0)
    pdb.gimp_floating_sel_anchor(floating_sel)
    pdb.gimp_layer_set_offsets(img1lay0,offset_x, offset_y)
    pdb.gimp_layer_resize_to_image_size(img1lay0)
    pdb.gimp_image_select_item(img1,0,img1lay0) 
    pdb.gimp_context_set_foreground(thlc)
    pdb.gimp_context_set_brush("2. Hardness 100")
    pdb.gimp_context_set_brush_size(1)
    pdb.gimp_edit_stroke(cutLay)
    cutLay.opacity = 100.0 
    pdb.gimp_selection_none(img1)
    szup2w = new_width + sizeup2
    szup2h = new_height+ sizeup2
    offsetw = int(sizeup2/2)
    offseth = int(sizeup2/2)
    pdb.gimp_image_resize(img1, szup2w, szup2h, offsetw, offseth)
    pdb.gimp_layer_resize_to_image_size(img1lay1)
    pdb.gimp_image_set_active_layer(img1,img1lay1)
    pdb.script_fu_drop_shadow(img1,img1lay1,4,4,15,'#000000',60,0)
    slabLay = pdb.gimp_layer_new(img1,szup2w,szup2h,1,'Slab RH',100.0,NORMAL_MODE)
    img1.add_layer(slabLay,5)
    pdb.gimp_image_set_active_layer(img1,slabLay)
    pdb.gimp_context_set_pattern(pat2)
    pdb.gimp_drawable_fill(slabLay, 4)
    img1disp=pdb.gimp_display_new(img1)

    #### the 2nd bevel
    pdb.script_fu_mhbevel3dimg22(wrkImage,slabLay,1,dbev2,dir,1,5,3,0,0)  ##### 2nd bevel
    img0 = gimp.image_list()[0]
    img0lay0,img0lay1,img0lay2,img0lay3,img0lay4,img0lay5,img0lay6=img0.layers
    img0lay0.name="Slab Face"
    pdb.gimp_image_lower_item_to_bottom(img0,img0lay0)
    pdb.gimp_image_raise_item(img0,img0lay0)
    image = gimp.image_list()[0]
    layerlist=image.layers
    full=layerlist[0:]
    part=layerlist[0:-2]
    for i in range(len(full)):
        pdb.gimp_item_set_visible(full[i],0)
    for i in range(len(part)):
        pdb.gimp_item_set_visible(part[i], 1)
        pdb.gimp_item_set_linked(part[i],1)
    img0lay4.name = "BG Drop Shadow"
    top_x, top_y = pdb.gimp_drawable_offsets(img0lay1)
    xx=sizeup2/2 
    yy=sizeup2/2 
    pdb.gimp_layer_set_offsets(img0lay1,xx,yy)
    newW2 = img0.width
    newH2 = img0.height
    slab2=pdb.gimp_layer_new(img0,newW2,newH2,1,"Slab Cut Edges",100,NORMAL_MODE)
    img0.add_layer(slab2, 5)
    pdb.gimp_image_set_active_layer(img0,img0lay0)
    pdb.gimp_selection_layer_alpha(img0lay0)
    pdb.gimp_context_set_foreground(bhlc)
    pdb.gimp_edit_stroke(slab2)
    slab2.opacity = 100.0 
    pdb.gimp_selection_none(img0)
    newW3 = newW2+sizeup3
    newH3 = newH2+sizeup3
    wallLay=pdb.gimp_layer_new(img0,newW3,newH3,1,"Wall",100,NORMAL_MODE)
    pdb.gimp_image_insert_layer(img0,wallLay,None,8)
    pdb.gimp_item_set_linked(slab2,1)
    pdb.gimp_item_set_linked(img0lay6,1) 
    pdb.gimp_item_set_linked(img0lay0,1)
    pdb.gimp_image_resize_to_layers(img0)
    pdb.gimp_layer_set_offsets(img0lay0, sizeup3/2-dbev2/2, sizeup3/2-dbev2/2) 
    pdb.gimp_layer_resize_to_image_size(wallLay)
    pdb.script_fu_drop_shadow(img0,img0lay6,20,20,15,'#000',50,0)
    pdb.gimp_image_lower_item_to_bottom(img0,wallLay)
    pdb.gimp_context_set_foreground(col3)
    pdb.gimp_edit_fill(wallLay, 0)
    bumpLay=pdb.gimp_layer_new(img0,newW3,newH3,1,"Bump",100,NORMAL_MODE)
    pdb.gimp_image_insert_layer(img0,bumpLay,None,10)
    pdb.gimp_layer_resize_to_image_size(bumpLay)    
    pdb.gimp_context_set_pattern(pat3)
    pdb.gimp_drawable_fill(bumpLay,4)
    pdb.plug_in_bump_map(img0,wallLay,bumpLay,135,45,bumpheight,0,0,0,0,1,0,0)
    img0 = gimp.image_list()[0]
    img0lay1,img0lay2,img0lay3,img0lay4,img0lay5,img0lay6,img0lay7,img0lay8,img0lay9,img0lay10,img0lay11=img0.layers 

### set all unlinked and not visible
    img0=gimp.image_list()[0]
    full=img0.layers
    for i in range(len(full)):
        pdb.gimp_item_set_visible(full[i],0)
    #unlink
    for i in range(len(full)):
        pdb.gimp_item_set_linked(full[i],0)

    pdb.gimp_image_select_item(img0,0,img0lay1)
    offset_x, offset_y = pdb.gimp_drawable_offsets(img0lay1)
    pdb.gimp_layer_set_offsets(img0lay1, offset_x-2, offset_y-1)
    pdb.gimp_image_select_item(img0,0,img0lay3)
    pdb.gimp_curves_spline(img0lay3,0,8,(0,0,2,1,4,15,150,90)) 
    pdb.gimp_selection_none(img0)
    pdb.python_layerfx_drop_shadow(img0,img0lay1,'#000000',75,9,0,NORMAL_MODE,8,10,135,1,1,0)
    glay0 = img0.active_layer 
    drawable = pdb.gimp_image_get_active_drawable(img0)    
    gworkLay = pdb.gimp_layer_new_from_drawable(drawable,img0)
    pdb.gimp_image_insert_layer(img0,gworkLay,None,0)
    pdb.gimp_image_remove_layer(img0,glay0)
    img0lay12 = pdb.gimp_image_merge_visible_layers(img0,0)

### put the details in the layers
    pdb.gimp_item_set_visible(img0lay12,0)
    img0lay1 = gworkLay
    pdb.gimp_image_select_item(img0,0,img0lay2)
    non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(img0)
    pdb.gimp_image_select_rectangle(img0, 0, x1, y1, x2-x1,y2-y1) 
    pdb.gimp_edit_clear(img0lay3)
    pdb.gimp_edit_clear(img0lay4)
    pdb.gimp_selection_none(img0)
    pdb.gimp_image_select_item(img0,0,img0lay6)  
    non_empty, xcut1, ycut1, xcut2, ycut2 = pdb.gimp_selection_bounds(img0)
    pdb.python_layerfx_drop_shadow(img0,img0lay6,'#000000',75,1,0,NORMAL_MODE,15,20,135,1,1,0)
    glay0 = img0.active_layer 
    drawable = pdb.gimp_image_get_active_drawable(img0)    
    gworkLay = pdb.gimp_layer_new_from_drawable(drawable,img0)
    pdb.gimp_image_insert_layer(img0,gworkLay,None,6)
    pdb.gimp_image_remove_layer(img0,glay0)
    img0lay13 = pdb.gimp_image_merge_visible_layers(img0,0)
    pdb.gimp_image_select_rectangle(img0,0,0,0,xcut2,ycut2)
    pdb.gimp_edit_clear(img0lay13)
    pdb.gimp_image_select_item(img0,0,img0lay8)
    pdb.gimp_selection_invert(img0)
    pdb.gimp_edit_clear(img0lay13)
    pdb.gimp_image_select_item(img0,0,img0lay7)
    pdb.gimp_edit_clear(img0lay8)
    img0lay13.opacity = 30.0
    img0lay6 = gworkLay
    pdb.gimp_selection_none(img0)
    pdb.gimp_curves_spline(img0lay8,0,8,(0,0,2,1,4,15,150,90)) 

#### get fresh list for img merge
    imglist = pdb.gimp_image_list()
    img0=gimp.image_list()[0]
    img2=gimp.image_list()[2]
    img2lay0,img2lay1,img2lay2,img2lay3,img2lay4,img2lay5=img2.layers

#### copy needed layers in proper order and clean up    
    layer_copy = pdb.gimp_layer_new_from_drawable(img2lay4,img0)
    pdb.gimp_image_insert_layer(img0,layer_copy,None,0)
    layer_copy = pdb.gimp_layer_new_from_drawable(img2lay3,img0)
    pdb.gimp_image_insert_layer(img0,layer_copy,None,0)
    layer_copy = pdb.gimp_layer_new_from_drawable(img2lay2,img0)
    pdb.gimp_image_insert_layer(img0,layer_copy,None,0)
    pdb.gimp_image_select_item(img0,0,layer_copy)
    pdb.plug_in_autocrop_layer(img0,layer_copy) 
    pdb.gimp_selection_none(img0)
    layer_copy = pdb.gimp_layer_new_from_drawable(img2lay1,img0)
    pdb.gimp_image_insert_layer(img0,layer_copy,None,0)
    layer_copy = pdb.gimp_layer_new_from_drawable(img2lay0,img0)
    pdb.gimp_image_insert_layer(img0,layer_copy,None,0)

#### - layer imports complete - no need for other images.
#### = reorg layers and layer names in img0, set opacity where needed
    img0lay1,img0lay2,img0lay3,img0lay4,img0lay5,img0lay6,img0lay7,mg0lay8,img0lay9,img0lay10,img0lay11,img0lay12,img0lay13,img0lay14,img0lay15,img0lay16,img0lay17,img0lay18,=img0.layers
    img0lay1.name='top edge ext HL'
    img0lay1.opacity=100.0
    img0lay2.name='top face'
    img0lay3.name='top face ext'
    img0lay4.name='top shadow ext'
    img0lay5.name='top text ext'
    img0lay6.name='top edge HL'
    img0lay7.name='top edge HL w/dropshadow'
    img0lay7.opacity=20.0
    img0lay8.name='top face'
    img0lay9.name='top face extrusion'
    img0lay10.name='top face bottom drop shadow'
    img0lay11.name='top text'
    img0lay12.name='slab edge HL'
    img0lay13.name='slab edge dropshadow'
    img0lay14.name='slab face'
    img0lay16.name='slab bottom dropshadow'
    img0lay17.name='wall'
    img0lay18.name='bump'

#### link imported layers and set offsets
    lays0=img0.layers
    five = lays0[:5]    
    for i in range(len(five)):
        pdb.gimp_item_set_linked(five[i],1)
    fx,fy = pdb.gimp_drawable_offsets(img0lay6)
    pdb.gimp_layer_set_offsets(img0lay1,fx,fy)
    five = lays0[:5]    
    for i in range(len(five)):
        pdb.gimp_item_set_linked(five[i],0)
    lays0=img0.layers
    for i in range(len(lays0)):
        pdb.gimp_item_set_visible(lays0[i],1)

#### make layer group for extruded and non extruded face
    group1 = pdb.gimp_layer_group_new(img0)
    pdb.gimp_image_insert_layer(img0,group1,None,0)
    group1.name='Top Face Extruded'

#### fill group1
    pdb.gimp_image_reorder_item(img0,img0lay5,group1,0)
    pdb.gimp_image_reorder_item(img0,img0lay4,group1,0)
    pdb.gimp_image_reorder_item(img0,img0lay3,group1,0)
    pdb.gimp_image_reorder_item(img0,img0lay2,group1,0)
    pdb.gimp_image_reorder_item(img0,img0lay1,group1,0)
    img0lay19 = pdb.gimp_layer_new_from_drawable(img0lay9,img0)
    pdb.gimp_image_insert_layer(img0,img0lay19,group1,2)
    img0lay19.name='top face extrusion dark'

#### create and fill group2 
    group2 = pdb.gimp_layer_group_new(img0)
    pdb.gimp_image_insert_layer(img0,group2,None,1)
    pdb.gimp_image_reorder_item(img0,img0lay11,group2,0)
    pdb.gimp_image_reorder_item(img0,img0lay10,group2,0)
    pdb.gimp_image_reorder_item(img0,img0lay9,group2,0)
    pdb.gimp_image_reorder_item(img0,img0lay8,group2,0)
    pdb.gimp_image_reorder_item(img0,img0lay7,group2,0)
    pdb.gimp_image_reorder_item(img0,img0lay6,group2,0)
    group2.name='Top Face not extruded'

#### minor fixes
    pdb.gimp_item_set_visible(group2,0)
    for i in range(len(lays0)):
        pdb.gimp_layer_resize_to_image_size(lays0[i])
    #use of layer not implemented: remove from group
    pdb.gimp_image_remove_layer(img0,img0lay2)
    #layer img0lay18 top face extrusion dark one pixel too far right
    qsx,qsy = pdb.gimp_drawable_offsets(img0lay19)
    pdb.gimp_layer_set_offsets(img0lay19,qsx-1,qsy)
    pdb.gimp_layer_resize_to_image_size(img0lay19)
    #layer img0lay6 top edge HL - one pixel too far left 
    qsx,qsy = pdb.gimp_drawable_offsets(img0lay6)
    pdb.gimp_layer_set_offsets(img0lay6,qsx+1,qsy)
    
    #cleanup and done 
    pdb.gimp_context_pop()
    img0disp=pdb.gimp_display_new(wrkImage)
    pdb.gimp_displays_flush
    pdb.gimp_image_set_filename(wrkImage, "OutCome Image")  
    pdb.gimp_display_delete(img0disp)
    pdb.gimp_display_delete(img1disp)


    return()


register(
    "BA_PhotomasterBlocksb",    
    "Automates an Extrusion Play.\Must have MH3DBevel.",   
    "Extrusion",
    "Brian", 
    "Brian Andersen ", 
    "Jun 2017",
    "BA Photomaster's Blocks Version 1b", 
    "RGB*", 
    [
      (PF_IMAGE, "image", "Input image",                           None),
      (PF_DRAWABLE,"idrawable", "Input drawable",                  None),
      (PF_SPINNER, "sizeup1",    "Top Block Text Border",  50,(2,200,2)),
      (PF_COLOR,   "thlc",       "Top Block Highlight Color",(1.0, 1.0, 1.0)),
      (PF_PATTERN, "pat1",       "Top Block Pattern",              None),
      (PF_SPINNER, "dbev1",      "Top Block 3D in pixels", 20,(2,200,1)),
      (PF_SPINNER, "sizeup2",    "Size Up for 2nd Block", 250,(2,500,2)),
      (PF_COLOR,   "bhlc",       "2nd Block Highlight Color",(1.0, 1.0, 1.0)),
      (PF_PATTERN, "pat2",       "2nd Blcok Pattern",              None),
      (PF_SPINNER, "dbev2",      "Second Block 3D in pixels", 20,(2,200,1)),
      (PF_SPINNER, "sizeup3",    "Size Up for Wall",         250,(2,500,2)),
      (PF_PATTERN, "pat3",       "Bump Pattern for Wall",          None),
      (PF_COLOR,   "col3",       "Wall Color",             (1.0, 1.0, 1.0)),
      (PF_SPINNER, "bumpheight", "Bump map height for Wall",   1,(1, 30,1)),
    ], 
    [
      (PF_DRAWABLE, "odrawable", "Output drawable", None),  
    ],
    BA_PhotomasterBlocksb,
    menu="<Image>/BrianWiring/",
    )

main()
